#pragma once

#include <ntddk.h>

typedef void
(*PCALLBACK_PROC)(
    IN PVOID Param
    );

void CallToProcessor(
				  IN CCHAR          Cpu,
				  IN PCALLBACK_PROC Proc,
				  IN PVOID          Param,
				  IN BOOLEAN        Syncronous
				  );

void CallToAllProcessors(
				  IN PCALLBACK_PROC Proc,
				  IN PVOID          Param,
				  IN BOOLEAN        NoSelfCall,
				  IN BOOLEAN        Syncronous
				  );

KIRQL GlobalLock(void);

void GlobalUnlock(
				IN KIRQL OldIrql
				);